Codeforces 825E Minimal Labels - 拓扑排序 - 贪心

You are given a directed acyclic graph with n vertices and m edges. There are no self-loops or multiple edges between any pair of vertices. Graph can be disconnected.

You should assign labels to all vertices in such a way that:

  • Labels form a valid permutation of length n — an integer sequence such that each integer from 1 to n appears exactly once in it.
  • If there exists an edge from vertex v to vertex u then labelv should be smaller than labelu.
  • Permutation should be lexicographically smallest among all suitable.

Find such sequence of labels to satisfy all the conditions.

Input

The first line contains two integer numbers n, m (2 ≤ n ≤ 105, 1 ≤ m ≤ 105).

Next m lines contain two integer numbers v and u (1 ≤ v, u ≤ n, v ≠ u) — edges of the graph. Edges are directed, graph doesn‘t contain loops or multiple edges.

Output

Print n numbers — lexicographically smallest correct permutation of labels of vertices.

Examples

Input

3 3 1 2 1 3 3 2

Output

1 3 2 

Input

4 5 3 1 4 1 2 3 3 4 2 4

Output

4 1 2 3 

Input

5 4 3 1 2 1 2 3 4 5

Output

3 1 2 4 5 


  题目大意 给定一个有向无环图,用1~n为所有顶点标号,每个顶点的标号互不相同,如果有有一条边从v连向u,则v的标号应比u小,输出字典序最小的标号方案。

  poj有一道一样的题,题解请戳这里

Code

  1 /**
  2  * Codeforces
  3  * Problem#825E
  4  * Accepted
  5  * Time: 46ms
  6  * Memory: 5300k
  7  */
  8 #include <bits/stdc++.h>
  9 #ifndef WIN32
 10 #define Auto "%lld"
 11 #else
 12 #define Auto "%I64d"
 13 #endif
 14 using namespace std;
 15 typedef bool boolean;
 16 const signed int inf = (signed)((1u << 31) - 1);
 17 const double eps = 1e-6;
 18 const int binary_limit = 128;
 19 #define smin(a, b) a = min(a, b)
 20 #define smax(a, b) a = max(a, b)
 21 #define max3(a, b, c) max(a, max(b, c))
 22 #define min3(a, b, c) min(a, min(b, c))
 23 template<typename T>
 24 inline boolean readInteger(T& u){
 25     char x;
 26     int aFlag = 1;
 27     while(!isdigit((x = getchar())) && x != ‘-‘ && x != -1);
 28     if(x == -1) {
 29         ungetc(x, stdin);
 30         return false;
 31     }
 32     if(x == ‘-‘){
 33         x = getchar();
 34         aFlag = -1;
 35     }
 36     for(u = x - ‘0‘; isdigit((x = getchar())); u = (u << 1) + (u << 3) + x - ‘0‘);
 37     ungetc(x, stdin);
 38     u *= aFlag;
 39     return true;
 40 }
 41
 42 ///map template starts
 43 typedef class Edge{
 44     public:
 45         int end;
 46         int next;
 47         Edge(const int end = 0, const int next = -1):end(end), next(next){}
 48 }Edge;
 49
 50 typedef class MapManager{
 51     public:
 52         int ce;
 53         int *h;
 54         vector<Edge> edge;
 55         MapManager(){}
 56         MapManager(int points):ce(0){
 57             h = new int[(const int)(points + 1)];
 58             memset(h, -1, sizeof(int) * (points + 1));
 59         }
 60         inline void addEdge(int from, int end){
 61             edge.push_back(Edge(end, h[from]));
 62             h[from] = ce++;
 63         }
 64         inline void addDoubleEdge(int from, int end){
 65             addEdge(from, end);
 66             addEdge(end, from);
 67         }
 68         Edge& operator [] (int pos) {
 69             return edge[pos];
 70         }
 71         inline void clear() {
 72             edge.clear();
 73             delete[] h;
 74         }
 75 }MapManager;
 76 #define m_begin(g, i) (g).h[(i)]
 77 #define m_endpos -1
 78 ///map template ends
 79
 80 int n, m;
 81 MapManager g;
 82 int* dag;
 83 int* dep;
 84
 85 inline boolean init() {
 86     if(!readInteger(n))    return false;
 87     readInteger(m);
 88     g = MapManager(n);
 89     dag = new int[(n + 1)];
 90     dep = new int[(n + 1)];
 91     memset(dag, 0, sizeof(int) * (n + 1));
 92     for(int i = 1, a, b; i <= m; i++) {
 93         readInteger(a);
 94         readInteger(b);
 95         g.addEdge(b, a);
 96         dag[a]++;
 97     }
 98     return true;
 99 }
100
101 priority_queue<int> que;
102 inline void topu() {
103     for(int i = 1; i <= n; i++)
104         if(!dag[i]) {
105             que.push(i);
106         }
107     int cnt = 0;
108     while(!que.empty()) {
109         int e = que.top();
110         dep[e] = cnt++;
111         que.pop();
112         for(int i = m_begin(g, e); i != m_endpos; i = g[i].next) {
113             int& eu = g[i].end;
114             dag[eu]--;
115             if(!dag[eu])
116                 que.push(eu);
117         }
118     }
119 }
120
121 inline void solve() {
122     topu();
123     for(int i = 1; i <= n; i++)
124         printf("%d ", n - dep[i]);
125 }
126
127 int main() {
128     init();
129     solve();
130     return 0;
131 }
时间: 2024-10-12 15:47:32

Codeforces 825E Minimal Labels - 拓扑排序 - 贪心的相关文章

Almost Acyclic Graph CodeForces - 915D (思维+拓扑排序判环)

Almost Acyclic Graph CodeForces - 915D time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output You are given a directed graph consisting of n vertices and m edges (each edge is directed, so it can

CodeForces 1294B Collecting Packages(排序+贪心)

http://codeforces.com/contest/1294/problem/B 大致题意: 一张图上有n个包裹,给出他们的坐标,一个机器人从(0,0)出发,只能向右(R)或向上(U),问能否收集到所有包裹,如果能,给出字典序最小的路径. 最开始当成搜索题了,其实可以排序+贪心写的. 1 #include <stdio.h> 2 #include <string.h> 3 #include <iostream> 4 #include <string>

BZOJ 2109 航空管制(拓扑排序+贪心)

绝世好题啊.. 题意:给出一个DAG,和每个点要求出现在这个DAG里面的拓扑排序的位置<=ti,求出所有可能的拓扑排序里面每个点出现的位置的最小值. 正着做不好做,考虑反着做,建立这个图的反图. 对于一个点出现的位置的最小值,就是n-这个点在反图中出现的位置的最大值. 也就是说拓扑排序时尽量把这个点i排在后面就行了.但是还需要满足一个限制,在反图中这个限制就是每个点在拓扑排序的位置>=n-ti. 于是我们每次拓扑排序从队列中取出点的时候,尽量取n-ti值最小的点,这样就能尽量使得当前处理的点i

BZOJ4010 HNOI2015 菜肴制作 拓扑排序+贪心

题意:给定限制条件(a,b)表示a必须在b之前,求所有合法序列中,小的数尽量在前面的方案 题解:首先我们根据限制条件建反向图,然后在反向图上求字典序最小的拓扑序(队列改为堆),逆序输出即可. #include <queue> #include <functional> #include <cstdio> #include <cstring> #include <cstdlib> #include <iostream> #include

[TJOI2014]Alice and Bob[拓扑排序+贪心]

题意 给出一个序列的以每一项结尾的 \(LIS\) 的长度a[],求一个序列,使得以每一项为开头的最长下降子序列的长度之和最大. \(n\leq 10^5\) . 分析 最优解一定是一个排列,因为如果两个数字的大小相同,完全可以区别他们的大小,以得到更多的贡献. 考虑的 \(a\) 给定的限制,显然对于所有的相同大小的 \(a\) ,前一项 \(a_{p_1}\) 要大于后一项 \(a_{p_2}\),否则一定会产生更长的上升子序列.连边\(p_2\rightarrow p_1\)表示 \(p_

[CSP-S模拟测试]:Permutation(线段树+拓扑排序+贪心)

题目描述 你有一个长度为$n$的排列$P$与一个正整数$K$你可以进行如下操作若干次使得排列的字典序尽量小对于两个满足$|i−j|\geqslant K$且$|P_i−P_j|=1$的下标$i$与$j$,交换$P_i$与$P_j$ 输入格式 第一行包括两个正整数$n$与$K$第二行包括$n$个正整数,第$i$个正整数表示$P_i$ 输出格式 输出一个新排列表示答案输出共$n$行,第$i$行表示$P_i$ 样例 样例输入: 8 34 5 7 8 3 1 2 6 样例输出: 12675348 数据范

[CF825E] Minimal Labels(反向建图,拓扑排序)

题目链接:http://codeforces.com/problemset/problem/825/E 题意:给一个有向图,求一个排列,这个排列是每一个点的序号,使得序号对应的点的排序符合拓扑序并且这个排列字典序最小. 直接跑字典序最小的拓扑排序是不行的,因为那样只是确保点的字典序而非这个排列的字典序,比如这个数据: 10 15 2 反过来考虑,点号大的入度为0的点一定排在后面,这个位置确定了.但是点好小的入度为0的未必一定排在前面,因为这个点之前可能有入度不为0,但是与此点无关的点在前面,按题

CodeForces 909E Coprocessor(无脑拓扑排序)

You are given a program you want to execute as a set of tasks organized in a dependency graph. The dependency graph is a directed acyclic graph: each task can depend on results of one or several other tasks, and there are no directed circular depende

【模拟题(63550802...)】解题报告【贪心】【拓扑排序】【找规律】【树相关】

目录: 1.A[树相关]    2.B[找规律]    3.C[贪心][拓扑排序] A. 描述(A 输入文件 : A.input 输出文件 : A.output)一个城市的构成是一颗n 个节点的树(2 ≤ n ≤ 200), 现在需要在树中找出两条不相交的路径(即两条路径不能有重边也不能有重点),使得路径的长度的乘积最大.输入描述第一行一个数n 表示这个城市一共有 n 个节点.接下来 n-1 行,每行两个数ai 和bi (1 ≤ ai,bi ≤ n ),分别表示从ai 到bi,有一条边,每条边的